Open CASCADE Technology  6.9.0
Public Member Functions
BRepFeat_MakeRevolutionForm Class Reference

MakeRevolutionForm Generates a surface of revolution in the feature as it slides along a revolved face in the basis shape. The semantics of mechanical features is built around giving thickness to a contour. This thickness can either be unilateral - on one side of the contour - or bilateral - on both sides. As in the semantics of form features, the thickness is defined by construction of shapes in specific contexts. The development contexts differ, however,in case of mechanical features. Here they include extrusion: More...

#include <BRepFeat_MakeRevolutionForm.hxx>

Inheritance diagram for BRepFeat_MakeRevolutionForm:
Inheritance graph
[legend]

Public Member Functions

 BRepFeat_MakeRevolutionForm ()
 initializes the linear form class. More...
 
 BRepFeat_MakeRevolutionForm (const TopoDS_Shape &Sbase, const TopoDS_Wire &W, const Handle< Geom_Plane > &Plane, const gp_Ax1 &Axis, const Standard_Real Height1, const Standard_Real Height2, const Standard_Integer Fuse, Standard_Boolean &Sliding)
 a contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between: More...
 
void Init (const TopoDS_Shape &Sbase, const TopoDS_Wire &W, const Handle< Geom_Plane > &Plane, const gp_Ax1 &Axis, const Standard_Real Height1, const Standard_Real Height2, const Standard_Integer Fuse, Standard_Boolean &Sliding)
 Initializes this construction algorithm A contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between: More...
 
void Add (const TopoDS_Edge &E, const TopoDS_Face &OnFace)
 Indicates that the edge <E> will slide on the face <OnFace>. Raises ConstructionError if the face does not belong to the basis shape, or the edge to the prismed shape. More...
 
void Perform ()
 Performs a prism from the wire to the plane along the basis shape S. Reconstructs the feature topologically. More...
 
Standard_Boolean Propagate (TopTools_ListOfShape &L, const TopoDS_Face &F, const gp_Pnt &FPoint, const gp_Pnt &LPoint, Standard_Boolean &falseside)
 
- Public Member Functions inherited from BRepFeat_RibSlot
virtual Standard_Boolean IsDeleted (const TopoDS_Shape &F)
 Returns true if F a TopoDS_Shape of type edge or face has been deleted. More...
 
virtual const
TopTools_ListOfShape
Modified (const TopoDS_Shape &F)
 Returns the list of generated Faces F. This list may be empty. More...
 
virtual const
TopTools_ListOfShape
Generated (const TopoDS_Shape &S)
 Returns a list TopTools_ListOfShape of the faces S created in the shape. More...
 
const TopTools_ListOfShapeFirstShape () const
 Returns the list of shapes created at the bottom of the created form. It may be an empty list. More...
 
const TopTools_ListOfShapeLastShape () const
 Returns the list of shapes created at the top of the created form. It may be an empty list. More...
 
const TopTools_ListOfShapeFacesForDraft () const
 Returns a list of the limiting and glueing faces generated by the feature. These faces did not originally exist in the basis shape. The list provides the information necessary for subsequent addition of a draft to a face. It may be an empty list. If a face has tangent edges, no draft is possible, and the tangent edges must subsequently be removed if you want to add a draft to the face. More...
 
const TopTools_ListOfShapeNewEdges () const
 Returns a list of the limiting and glueing edges generated by the feature. These edges did not originally exist in the basis shape. The list provides the information necessary for subsequent addition of fillets. It may be an empty list. More...
 
const TopTools_ListOfShapeTgtEdges () const
 Returns a list of the tangent edges among the limiting and glueing edges generated by the feature. These edges did not originally exist in the basis shape and are tangent to the face against which the feature is built. The list provides the information necessary for subsequent addition of fillets. It may be an empty list. If an edge is tangent, no fillet is possible, and the edge must subsequently be removed if you want to add a fillet. More...
 
BRepFeat_StatusError CurrentStatusError () const
 
- Public Member Functions inherited from BRepBuilderAPI_MakeShape
virtual void Delete ()
 
virtual ~BRepBuilderAPI_MakeShape ()
 
virtual void Build ()
 This is called by Shape(). It does nothing but may be redefined. More...
 
virtual const TopoDS_ShapeShape () const
 Returns a shape built by the shape construction algorithm. Raises exception StdFail_NotDone if the shape was not built. More...
 
 operator TopoDS_Shape () const
 
- Public Member Functions inherited from BRepBuilderAPI_Command
virtual ~BRepBuilderAPI_Command ()
 
virtual Standard_Boolean IsDone () const
 
void Check () const
 Raises NotDone if done is false. More...
 

Additional Inherited Members

- Static Public Member Functions inherited from BRepFeat_RibSlot
static Standard_Real IntPar (const Handle< Geom_Curve > &C, const gp_Pnt &P)
 
static TopoDS_Face ChoiceOfFaces (TopTools_ListOfShape &faces, const Handle< Geom_Curve > &cc, const Standard_Real par, const Standard_Real bnd, const Handle< Geom_Plane > &Pln)
 
- Protected Member Functions inherited from BRepFeat_RibSlot
 BRepFeat_RibSlot ()
 Redefines the empty constructor. More...
 
void LFPerform ()
 General perform method... More...
 
gp_Pnt CheckPoint (const TopoDS_Edge &e, const Standard_Real bnd, const Handle< Geom_Plane > &Pln)
 
gp_Dir Normal (const TopoDS_Face &F, const gp_Pnt &P)
 
void EdgeExtention (TopoDS_Edge &e, const Standard_Real bnd, const Standard_Boolean FirstLast)
 
Standard_Real HeightMax (const TopoDS_Shape &theSbase, const TopoDS_Shape &theSUntil, gp_Pnt &p1, gp_Pnt &p2)
 
Standard_Boolean ExtremeFaces (const Standard_Boolean RevolRib, const Standard_Real bnd, const Handle< Geom_Plane > &Pln, TopoDS_Edge &FirstEdge, TopoDS_Edge &LastEdge, TopoDS_Face &FirstFace, TopoDS_Face &LastFace, TopoDS_Vertex &FirstVertex, TopoDS_Vertex &LastVertex, Standard_Boolean &OnFirstFace, Standard_Boolean &OnLastFace, Standard_Boolean &PtOnFirstEdge, Standard_Boolean &PtOnLastEdge, TopoDS_Edge &OnFirstEdge, TopoDS_Edge &OnLastEdge)
 
void PtOnEdgeVertex (const Standard_Boolean RevolRib, const TopoDS_Shape &shape, const gp_Pnt &point, const TopoDS_Vertex &FirstVertex, const TopoDS_Vertex &LastVertex, Standard_Boolean &PtOnEdge, TopoDS_Edge &OnEdge, Standard_Boolean &PtOnVertex, TopoDS_Vertex &OnVertex)
 
Standard_Boolean SlidingProfile (TopoDS_Face &Prof, const Standard_Boolean RevolRib, const Standard_Real myTol, Standard_Integer &Concavite, const Handle< Geom_Plane > &myPln, const TopoDS_Face &BndFace, const gp_Pnt &CheckPnt, const TopoDS_Face &FirstFace, const TopoDS_Face &LastFace, const TopoDS_Vertex &FirstVertex, const TopoDS_Vertex &LastVertex, const TopoDS_Edge &FirstEdge, const TopoDS_Edge &LastEdge)
 
Standard_Boolean NoSlidingProfile (TopoDS_Face &Prof, const Standard_Boolean RevolRib, const Standard_Real myTol, Standard_Integer &Concavite, const Handle< Geom_Plane > &myPln, const Standard_Real bnd, const TopoDS_Face &BndFace, const gp_Pnt &CheckPnt, const TopoDS_Face &FirstFace, const TopoDS_Face &LastFace, const TopoDS_Vertex &FirstVertex, const TopoDS_Vertex &LastVertex, const TopoDS_Edge &FirstEdge, const TopoDS_Edge &LastEdge, const Standard_Boolean OnFirstFace, const Standard_Boolean OnLastFace)
 
void UpdateDescendants (const LocOpe_Gluer &G)
 Updates the data structures of descendant shapes during the glueing operation.Returns the modified, generated and deleted faces during the course of the glueing operation. More...
 
void UpdateDescendants (const Handle< TopOpeBRepBuild_HBuilder > &B, const TopoDS_Shape &SResult, const Standard_Boolean SkipFace=Standard_False)
 
void UpdateDescendants (const BRepAlgoAPI_BooleanOperation &aBOP, const TopoDS_Shape &SResult, const Standard_Boolean SkipFace=Standard_False)
 
- Protected Member Functions inherited from BRepBuilderAPI_MakeShape
 BRepBuilderAPI_MakeShape ()
 
- Protected Member Functions inherited from BRepBuilderAPI_Command
 BRepBuilderAPI_Command ()
 Set done to False. More...
 
void Done ()
 Set done to true. More...
 
void NotDone ()
 Set done to false. More...
 
- Protected Attributes inherited from BRepFeat_RibSlot
gp_Pnt myFirstPnt
 
gp_Pnt myLastPnt
 
Standard_Boolean myFuse
 
Standard_Boolean mySliding
 
TopTools_DataMapOfShapeListOfShape myMap
 
TopTools_DataMapOfShapeListOfShape myLFMap
 
TopoDS_Shape myFShape
 
TopoDS_Shape myLShape
 
BRepFeat_PerfSelection myPerfSelection
 
TopoDS_Wire myWire
 
TopoDS_Shape mySbase
 
TopoDS_Face mySkface
 
TopoDS_Face myPbase
 
TopoDS_Shape myGShape
 
TopoDS_Shape mySUntil
 
TopTools_DataMapOfShapeShape myGluedF
 
TopTools_ListOfShape myNewEdges
 
TopTools_ListOfShape myTgtEdges
 
TopTools_ListOfShape myFacesForDraft
 
BRepFeat_StatusError myStatusError
 
- Protected Attributes inherited from BRepBuilderAPI_MakeShape
TopoDS_Shape myShape
 
TopTools_ListOfShape myGenerated
 

Detailed Description

MakeRevolutionForm Generates a surface of revolution in the feature as it slides along a revolved face in the basis shape. The semantics of mechanical features is built around giving thickness to a contour. This thickness can either be unilateral - on one side of the contour - or bilateral - on both sides. As in the semantics of form features, the thickness is defined by construction of shapes in specific contexts. The development contexts differ, however,in case of mechanical features. Here they include extrusion:

Constructor & Destructor Documentation

BRepFeat_MakeRevolutionForm::BRepFeat_MakeRevolutionForm ( )

initializes the linear form class.

BRepFeat_MakeRevolutionForm::BRepFeat_MakeRevolutionForm ( const TopoDS_Shape Sbase,
const TopoDS_Wire W,
const Handle< Geom_Plane > &  Plane,
const gp_Ax1 Axis,
const Standard_Real  Height1,
const Standard_Real  Height2,
const Standard_Integer  Fuse,
Standard_Boolean Sliding 
)

a contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between:

  • removing matter with a Boolean cut using the setting 0 in case of the groove
  • adding matter with Boolean fusion using the setting 1 in case of the rib.

Member Function Documentation

void BRepFeat_MakeRevolutionForm::Add ( const TopoDS_Edge E,
const TopoDS_Face OnFace 
)

Indicates that the edge <E> will slide on the face <OnFace>. Raises ConstructionError if the face does not belong to the basis shape, or the edge to the prismed shape.

void BRepFeat_MakeRevolutionForm::Init ( const TopoDS_Shape Sbase,
const TopoDS_Wire W,
const Handle< Geom_Plane > &  Plane,
const gp_Ax1 Axis,
const Standard_Real  Height1,
const Standard_Real  Height2,
const Standard_Integer  Fuse,
Standard_Boolean Sliding 
)

Initializes this construction algorithm A contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between:

  • removing matter with a Boolean cut using the setting 0 in case of the groove
  • adding matter with Boolean fusion using the setting 1 in case of the rib.
void BRepFeat_MakeRevolutionForm::Perform ( )

Performs a prism from the wire to the plane along the basis shape S. Reconstructs the feature topologically.

Standard_Boolean BRepFeat_MakeRevolutionForm::Propagate ( TopTools_ListOfShape L,
const TopoDS_Face F,
const gp_Pnt FPoint,
const gp_Pnt LPoint,
Standard_Boolean falseside 
)

The documentation for this class was generated from the following file: